/*
 * Copyright (C) 2001 University Corporation for Atmospheric Research 
 *       
 * $Id: cfftAnalysisR8.c,v 1.1 2001/08/06 20:33:31 mt Exp $
 */

#include "cfft.h"

void cfftAnalysisR8(complex *x,complex *y,complex omega,int L,int N)
{
  complex w,s0,s1,s2,s3,s4,s5,s6,s7;
  complex t0,t1,t2,t3,t4,t5,t6,t7;
  complex *x0,*x1,*x2,*x3,*x4,*x5,*x6,*x7;
  complex *y0,*y1,*y2,*y3,*y4,*y5,*y6,*y7;
  real c=1.0/STK_R2;

  int j,i;
  x0=x;
  x1=x0+L*N;
  x2=x1+L*N;
  x3=x2+L*N;
  x4=x3+L*N;
  x5=x4+L*N;
  x6=x5+L*N;
  x7=x6+L*N;
  for(j=0;j<N;j++)
    { 
      y0=y+8*L*j;
      y1=y0+L;
      y2=y1+L;
      y3=y2+L;
      y4=y3+L;
      y5=y4+L;
      y6=y5+L;
      y7=y6+L;
      t0.re=x0->re;
      t0.im=x0->im;
      t1.re=x1->re;
      t1.im=x1->im;
      t2.re=x2->re;
      t2.im=x2->im;
      t3.re=x3->re;
      t3.im=x3->im;
      t4.re=x4->re;
      t4.im=x4->im;
      t5.re=x5->re;
      t5.im=x5->im;
      t6.re=x6->re;
      t6.im=x6->im;
      t7.re=x7->re;
      t7.im=x7->im;
      s0.re=t0.re-t4.re;
      s0.im=t0.im-t4.im;
      s1.re=t1.re-t5.re;
      s1.im=t1.im-t5.im;
      s2.re=t2.re-t6.re;
      s2.im=t2.im-t6.im;
      s3.re=t3.re-t7.re;
      s3.im=t3.im-t7.im;
      s4.re=t0.re+t4.re;
      s4.im=t0.im+t4.im;
      s5.re=t1.re+t5.re;
      s5.im=t1.im+t5.im;
      s6.re=t2.re+t6.re;
      s6.im=t2.im+t6.im;
      s7.re=t3.re+t7.re;
      s7.im=t3.im+t7.im;
      t0.re=s4.re+s6.re;
      t0.im=s4.im+s6.im;
      t1.re=s5.re+s7.re;
      t1.im=s5.im+s7.im;
      t2.re=s4.re-s6.re;
      t2.im=s4.im-s6.im;
      t3.re=s5.re-s7.re;
      t3.im=s5.im-s7.im;
      t4.re=s0.re+s2.im;
      t4.im=s0.im+s2.re;
      t5.re=c*(s1.re-s3.re);
      t5.im=c*(s1.im-s3.im);
      t6.re=s0.re-s2.im;
      t6.im=s0.im-s2.re;
      t7.re=c*(s1.re+s3.re);
      t7.im=c*(s1.im+s3.im);
      y0->re=t0.re+t1.re;
      y0->im=t0.im+t1.im;
      y1->re=t4.re+t5.re+t7.im;
      y1->im=t6.im+t5.im-t7.re;
      y2->re=t2.re+t3.im;
      y2->im=t2.im-t3.re;
      y3->re=t6.re-t5.re+t7.im;
      y3->im=t4.im-t5.im-t7.re;
      y4->re=t0.re-t1.re;
      y4->im=t0.im-t1.im;
      y5->re=t4.re-t5.re-t7.im;
      y5->im=t6.im-t5.im+t7.re;
      y6->re=t2.re-t3.im;
      y6->im=t2.im+t3.re;
      y7->re=t6.re+t5.re-t7.im;
      y7->im=t4.im+t5.im+t7.re;
      w.re=omega.re+1.0;
      w.im=omega.im;
      x0++;
      x1++;
      x2++;
      x3++;
      x4++;
      x5++;
      x6++;
      x7++;
      y0++;
      y1++;
      y2++;
      y3++;
      y4++;
      y5++;
      y6++;
      y7++;
      for(i=1;i<L;i++)
	{
	  s2.re=w.re*w.re-w.im*w.im;
	  s2.im=2.0*w.re*w.im;
	  s3.re=s2.re*w.re-s2.im*w.im;
	  s3.im=s2.re*w.im+s2.im*w.re; 
	  s4.re=s3.re*w.re-s3.im*w.im;
	  s4.im=s3.re*w.im+s3.im*w.re; 
	  s5.re=s4.re*w.re-s4.im*w.im;
	  s5.im=s4.re*w.im+s4.im*w.re; 
	  s6.re=s5.re*w.re-s5.im*w.im;
	  s6.im=s5.re*w.im+s5.im*w.re; 
	  s7.re=s6.re*w.re-s6.im*w.im;
	  s7.im=s6.re*w.im+s6.im*w.re; 

	  t0.re=x0->re;
	  t0.im=x0->im;
	  t1.re=w.re*x1->re-w.im*x1->im;
	  t1.im=w.re*x1->im+w.im*x1->re;
	  t2.re=s2.re*x2->re-s2.im*x2->im;
	  t2.im=s2.re*x2->im+s2.im*x2->re;
	  t3.re=s3.re*x3->re-s3.im*x3->im;
	  t3.im=s3.re*x3->im+s3.im*x3->re;
	  t4.re=s4.re*x4->re-s4.im*x4->im;
	  t4.im=s4.re*x4->im+s4.im*x4->re;
	  t5.re=s5.re*x5->re-s5.im*x5->im;
	  t5.im=s5.re*x5->im+s5.im*x5->re;
	  t6.re=s6.re*x6->re-s6.im*x6->im;
	  t6.im=s6.re*x6->im+s6.im*x6->re;
	  t7.re=s7.re*x7->re-s7.im*x7->im;
	  t7.im=s7.re*x7->im+s7.im*x7->re;
	  s0.re=t0.re-t4.re;
	  s0.im=t0.im-t4.im;
	  s1.re=t1.re-t5.re;
	  s1.im=t1.im-t5.im;
	  s2.re=t2.re-t6.re;
	  s2.im=t2.im-t6.im;
	  s3.re=t3.re-t7.re;
	  s3.im=t3.im-t7.im;
	  s4.re=t0.re+t4.re;
	  s4.im=t0.im+t4.im;
	  s5.re=t1.re+t5.re;
	  s5.im=t1.im+t5.im;
	  s6.re=t2.re+t6.re;
	  s6.im=t2.im+t6.im;
	  s7.re=t3.re+t7.re;
	  s7.im=t3.im+t7.im;
	  t0.re=s4.re+s6.re;
	  t0.im=s4.im+s6.im;
	  t1.re=s5.re+s7.re;
	  t1.im=s5.im+s7.im;
	  t2.re=s4.re-s6.re;
	  t2.im=s4.im-s6.im;
	  t3.re=s5.re-s7.re;
	  t3.im=s5.im-s7.im;
	  t4.re=s0.re+s2.im;
	  t4.im=s0.im+s2.re;
	  t5.re=c*(s1.re-s3.re);
	  t5.im=c*(s1.im-s3.im);
	  t6.re=s0.re-s2.im;
	  t6.im=s0.im-s2.re;
	  t7.re=c*(s1.re+s3.re);
	  t7.im=c*(s1.im+s3.im);
	  y0->re=t0.re+t1.re;
	  y0->im=t0.im+t1.im;
	  y1->re=t4.re+t5.re+t7.im;
	  y1->im=t6.im+t5.im-t7.re;
	  y2->re=t2.re+t3.im;
	  y2->im=t2.im-t3.re;
	  y3->re=t6.re-t5.re+t7.im;
	  y3->im=t4.im-t5.im-t7.re;
	  y4->re=t0.re-t1.re;
	  y4->im=t0.im-t1.im;
	  y5->re=t4.re-t5.re-t7.im;
	  y5->im=t6.im-t5.im+t7.re;
	  y6->re=t2.re-t3.im;
	  y6->im=t2.im+t3.re;
	  y7->re=t6.re+t5.re-t7.im;
	  y7->im=t4.im+t5.im+t7.re;
	  t1.re=omega.re*w.re-w.im*omega.im+w.re;
	  t1.im=omega.re*w.im+w.re*omega.im+w.im;
	  w.re=t1.re;
	  w.im=t1.im;
	  x0++;
	  x1++;
	  x2++;
	  x3++;
	  x4++;
	  x5++;
	  x6++;
	  x7++;
	  y0++;
	  y1++;
	  y2++;
	  y3++;
	  y4++;
	  y5++;
	  y6++;
	  y7++;
	}
    }
}	  

